/*
 * Lbl
 *
 * David Harrison
 * University of California, Berkley
 * 1990
 *
 * Lbl is a subclass of the Athena Label widget that uses
 * a slightly different method to compute preferred geometry.
 * This new method returns the actual size of the widget when
 * the resize resource is set.  Everything else about the
 * class is inherited.
 *
 * These are the private definitions for the class.
 */

#ifndef _LblP_h
#define _LblP_h

#include "Lbl.h"
#include <X11/Xaw/LabelP.h>

/* No new class fields */
typedef struct {int foo;} LblClassPart;

/* Full class record declaration */
typedef struct _LblClassRec {
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    LabelClassPart	label_class;
    LblClassPart	lbl_class;
} LblClassRec;

extern LblClassRec lblClassRec;

/* No new instance fields */
typedef struct {int foo;} LblPart;

/* Full instance record */
typedef struct _LblRec {
    CorePart	core;
    SimplePart	simple;
    LabelPart	label;
    LblPart	lbl;
} LblRec;

#endif /* _LblP_h */
