/* $XConsortium: LImageP.h,v 1.2 88/10/25 17:37:59 swick Exp $ */
/* Copyright	Massachusetts Institute of Technology	1987, 1988 */

#ifndef _LImageP_h
#define _LImageP_h

#include "LImage.h"
/* include superclass private header file */
#include <X11/CoreP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRSqPixmap		"sqPixmap"
typedef struct _SqPixmap {
    unsigned int width, height;
    Pixmap map;
} SqPixmap, *SqPixmapPtr;

/*
 * Class Record
 */

typedef struct {
    int empty;
} LImageClassPart;

/*
 * Class Hierarchy
 */

typedef struct _LImageClassRec {
    CoreClassPart	core_class;
    LImageClassPart	lImage_class;
} LImageClassRec;

extern LImageClassRec lImageClassRec;

typedef struct {
    String line;
    int count;
    int width;
} LILabelLine;

typedef struct {
    /* resources */
    Pixel foreground;
    XFontStruct *font;
    String label;
    SqPixmap image;
    Boolean select;
    XtCallbackList callbacks;
    Dimension padding;
    int click_thres;
    /* private state */
    int num_lines;
    LILabelLine *line_array;
    int max_line_width;
    int all_height;
    Time last_ms;
    int click_count;
} LImagePart;

/*
 * Instance hierarchy
 */

typedef struct _LImageRec {
    CorePart		core;
    LImagePart		lImage;
} LImageRec;

#endif  /* _LImageP_h */
