/*LINTLIBRARY*/
#include "copyright.h"
#include "port.h"

/*
 * dialog manager stubs
 *
 * Rick L Spickelmier, 7/24/88
 */

/* #include "vemDM.h"   */
#include "rpcApp.h"

/*
 * vem dialog manager stuff - only moded ones
 */

/*ARGSUSED*/
vemStatus
dmMultiWhich(title, count, items, item_func, help_buf)
char *title;
int count;
dmWhichItem *items;
int (*item_func)();
char *help_buf;
{
    int i;
    long returnCode, dummy;
    
    RPCASSERT(RPCSendLong(DM_MULTI_WHICH_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendString(title, RPCSendStream));
    RPCASSERT(RPCSendLong((long) count, RPCSendStream));
    
    for (i = 0; i < count; i++) {
	RPCASSERT(RPCSendString(items[i].itemName, RPCSendStream));
    }
    
    RPCASSERT(RPCSendString(help_buf, RPCSendStream));
    
    RPCFLUSH(RPCSendStream);
    
    RPCASSERT(RPCReceiveLong(&returnCode, RPCReceiveStream));
    
    for (i = 0; i < count; i++) {
	RPCASSERT(RPCReceiveLong(&dummy, RPCReceiveStream));
	items[i].flag = (int) dummy;
    }

    return (vemStatus) returnCode;
}


/*ARGSUSED*/
vemStatus
dmWhichOne(title, count, items, itemSelected, item_func, help_buf)
char *title;
int count;
dmWhichItem *items;
int *itemSelected;
int (*item_func)();
char *help_buf;
{
    int i;
    long returnCode, item, dummy;
        
    RPCASSERT(RPCSendLong(DM_WHICH_ONE_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendString(title, RPCSendStream));
    RPCASSERT(RPCSendLong((long) count, RPCSendStream));
    
    for (i = 0; i < count; i++) {
	RPCASSERT(RPCSendString(items[i].itemName, RPCSendStream));
    }
    
    RPCASSERT(RPCSendString(help_buf, RPCSendStream));
    
    RPCFLUSH(RPCSendStream);
    
    RPCASSERT(RPCReceiveLong(&returnCode, RPCReceiveStream));
    
    RPCASSERT(RPCReceiveLong(&item, RPCReceiveStream));

    *itemSelected = (int) item;
      
    for (i = 0; i < count; i++) {
	RPCASSERT(RPCReceiveLong(&dummy, RPCReceiveStream));
	items[i].flag = (int) dummy;
    }
    
    return (vemStatus) returnCode;
}


vemStatus
dmMultiText(title, count, items)
char *title;
int count;
dmTextItem *items;
{
    int i;
    long returnCode;
    
    RPCASSERT(RPCSendLong(DM_MULTI_TEXT_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendString(title, RPCSendStream));
    RPCASSERT(RPCSendLong((long) count, RPCSendStream));
    
    for (i = 0; i < count; i++) {
	RPCASSERT(RPCSendString(items[i].itemPrompt, RPCSendStream));
	RPCASSERT(RPCSendLong((long) items[i].rows, RPCSendStream));
	RPCASSERT(RPCSendLong((long) items[i].cols, RPCSendStream));
	RPCASSERT(RPCSendString(items[i].value, RPCSendStream));
    }

    RPCFLUSH(RPCSendStream);

    RPCASSERT(RPCReceiveLong(&returnCode, RPCReceiveStream));

    for (i = 0; i < count; i++) {
	RPCASSERT(RPCReceiveString(&(items[i].value), RPCReceiveStream));
    }
        
    return (vemStatus) returnCode;
}


vemStatus
dmConfirm(title, message, yesButton, noButton)
char *title;
char *message;
char *yesButton, *noButton;
{
    long returnCode;
    
    RPCASSERT(RPCSendLong(DM_CONFIRM_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendString(title, RPCSendStream));
    RPCASSERT(RPCSendString(message, RPCSendStream));
    RPCASSERT(RPCSendString(yesButton, RPCSendStream));
    RPCASSERT(RPCSendString(noButton, RPCSendStream));

    RPCFLUSH(RPCSendStream);

    RPCASSERT(RPCReceiveLong(&returnCode, RPCReceiveStream));

    return (vemStatus) returnCode;
}


void
dmMessage(title, message, formatp)
char *title;
char *message;
int formatp;
{
    RPCASSERT(RPCSendLong(DM_MESSAGE_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendString(title, RPCSendStream));
    RPCASSERT(RPCSendString(message, RPCSendStream));
    RPCASSERT(RPCSendLong(formatp, RPCSendStream));
    RPCFLUSH(RPCSendStream);
    return;
}
