#include "copyright.h"
#include "port.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include "rpc.h"

char *optProgName = "gentest";

/*ARGSUSED*/
int
UserMain(display, spot, arglist, uow, array)
char *display;
struct RPCSpot *spot;
lsList arglist;
long uow;
RPCFunction **array;
{
    octObject facet;
    octGenerator gen;
    octObject object;
    struct timeb start, end;
    char buffer[1024];
    double elapsedTime;
    
    long count = 0;

    facet.objectId = spot->facet;
    
    ftime(&start);

    (void) octInitGenContentsSpecial(&facet, OCT_ALL_MASK, &gen);

    while(octGenerate(&gen, &object) == OCT_OK) {
	count++;
    }

    ftime(&end);
    
    sprintf(buffer, "starting time is %f\n",
	    (double) start.time + (double) start.millitm / 1000.0);
    VEMMSG(buffer);
    sprintf(buffer, "%d items\n", count);
    VEMMSG(buffer);
    sprintf(buffer, "end time is %f\n",
	    (double) end.time + (double) end.millitm / 1000.0);
    VEMMSG(buffer);
    elapsedTime = (double) (end.time - start.time)
      + (double) (end.millitm - start.millitm) / 1000.0;

    if (count > 0) {
	sprintf(buffer, "delta time is %f\ntime per object is %f\n",
		elapsedTime, elapsedTime / (double) count);
	VEMMSG(buffer);
    }
    
    RPCExit(0);
}




